﻿using DemoTelerik.Models;
using DemoTelerik.ViewModels;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Web.Mvc;

namespace DemoTelerik.Controllers
{
   public class HomeController : Controller
   {
      const string Data = "[{'Id': 1, 'ApplicationDate': '2020-01-26'},{'Id': 2, 'ApplicationDate': '2020-01-26'}]";

      public ActionResult Index()
      {
         return View();
      }

      [HttpPost]
      public ActionResult GetData([DataSourceRequest] DataSourceRequest request)
      {
         var myData = JsonConvert.DeserializeObject<IEnumerable<Data>>(Data);
         return Json(myData.ToDataSourceResult(request, DataViewModel.FromEntity));
      }

      [HttpPost]
      public ActionResult Save([DataSourceRequest] DataSourceRequest request,
                               [Bind(Prefix = "created")] IEnumerable<DataViewModel> toCreate,
                               [Bind(Prefix = "destroyed")] IEnumerable<DataViewModel> toDelete,
                               [Bind(Prefix = "updated")] IEnumerable<DataViewModel> toUpdate)
      {
         var myNeModel = new
         {
            Deleteted = toDelete, //Only which tha success
            Created = toCreate, //Only which tha success
            Updated = toUpdate //Only which tha success
         };

         return Json(new[] { myNeModel }.ToDataSourceResult(request, ModelState));
      }
   }
}