﻿using Kendo.Mvc.UI.Fluent;
using System;
using System.Linq.Expressions;

namespace DemoTelerik.Helpers
{
   public static class HtmlHelperKendo
   {
      /// <summary>
      /// 
      /// </summary>
      /// <typeparam name="TModel"></typeparam>
      /// <param name="gcf"></param>
      /// <param name="expression"></param>
      /// <param name="format"></param>
      /// <returns></returns>
      public static GridBoundColumnBuilder<TModel> BoundDate<TModel>(this GridColumnFactory<TModel> gcf, Expression<Func<TModel, DateTime>> expression, string format)
         where TModel : class
      {
         if (gcf is null) throw new ArgumentNullException(nameof(gcf));

         var property = ((MemberExpression)expression.Body).Member;
         return gcf.Bound(expression).Template(t => "@<text></text>").ClientTemplate($"#=kendo.toString(kendo.parseDate({property.Name}),'{format}')#");
      }

      /// <summary>
      /// 
      /// </summary>
      /// <typeparam name="TModel"></typeparam>
      /// <param name="gcf"></param>
      /// <param name="expression"></param>
      /// <param name="format"></param>
      /// <returns></returns>
      public static GridBoundColumnBuilder<TModel> BoundDate<TModel>(this GridColumnFactory<TModel> gcf, Expression<Func<TModel, DateTime?>> expression, string format)
         where TModel : class
      {
         if (gcf is null) throw new ArgumentNullException(nameof(gcf));

         var property = ((MemberExpression)expression.Body).Member;

         return gcf.Bound(expression).Template(t => "@<text></text>").ClientTemplate($"#= {property.Name} ? kendo.toString(kendo.parseDate({property.Name}),'{format}') : '' #");
      }
   }
}