﻿(function () {
   function findRootUrl(rootDir) {
      var rootUrl = false;
      if (rootDir !== '/') {
         var rootIndex = window.location.href.toLowerCase().indexOf(rootDir.toLowerCase());

         if (rootIndex > 0) {
            rootUrl = window.location.href.substring(0, rootIndex + rootDir.length);
         }
      }
      if (rootUrl === false) {
         rootUrl = window.location.protocol + '//' + window.location.host;
      }

      return rootUrl;
   }

   var rootUrl = findRootUrl(window.jsRoot); //jsRoot est initialisé dans le layout!

   //Créer un URL en tenant compte des répertoires virtuels.
   function creerUrl(destination) {
      return rootUrl + destination;
   }

   $.kendo = {
      button: {
         save: function (e) {
            const grid = $("#DataGrid").data("kendoGrid");
            grid.saveChanges();
         }
      },
      grid: {
         parseDate: function (e) {
            var date = kendo.parseDate(e);
            return date ? date.toJSON() : date;
         },
         saveChanges: function (e, controller) {
            var result;
            var errors;

            $.ajax({
               type: 'POST',
               url: creerUrl(`/${controller}/Save`),
               async: false,
               data: e.data,
               contentType: "application/x-www-form-urlencoded",
               success: function (r) {
                  result = r.Data[0];
                  errors = r.Errors;
               },
               updatedZone: "#DataGrid"
            });

            e.success(result.Updated, "update");
            e.success(result.Created, "create");
            e.success(result.Destroyed, "destroy");
            e.error(null, "customerror", errors);
         },
         onHandleError: function (e) {
            this.cancelChanges();

            $.each(e.errorThrown, function (i) {
               var detail = { 'Key': i.replaceAll("'", ""), 'Value': e.errorThrown[i] };

               //Erreur générique à afficher dans la notification (Toast)
               if (detail.Key === "'0'") {
                  $.each(detail.Value, function (j) {
                     notification += "<br>" + detail.Value[j];
                  });
               }
               //Erreur spécifique à afficher directement dans le grid
               else {
                  const event = new CustomEvent('onErrorThrown', { detail: detail });
                  dispatchEvent(event);
               }
            });

            //Show error To UI
         }
      }
   }
})();