﻿using DemoTelerik.App_GlobalResources;
using DemoTelerik.Models;
using System;
using System.ComponentModel.DataAnnotations;

namespace DemoTelerik.ViewModels
{
   public class DataViewModel
   {
      public int Id { get; set; }

      [
         Display(Name = "ApplicationDate", ResourceType = typeof(Resources)),
         Required(ErrorMessageResourceName = "Mandatory", ErrorMessageResourceType = typeof(Resources)),
         DataType(DataType.Date)
      ]
      public DateTime ApplicationDate { get; set; }

      [
         Display(Name = "EndDate", ResourceType = typeof(Resources)),
         DataType(DataType.Date)
      ]
      public DateTime? EndDate { get; set; }

      internal static DataViewModel FromEntity(Data d)
      {
         return new DataViewModel
         {
            Id = d.Id,
            ApplicationDate = d.ApplicationDate,
            EndDate = d.EndDate
         };
      }

      internal Data ToEntite()
      {
         return new Data
         {
            Id = Id,
            ApplicationDate = ApplicationDate,
            EndDate = EndDate
         };
      }
   }
}
